searchNodes=[{"doc":"Well-structured Arrays with fast random-element-access for Elixir, offering a common interface with multiple implementations with varying performance guarantees that can be switched in your configuration. Using Arrays Some simple examples: Constructing Arrays By calling Arrays.new or Arrays.empty : iex&gt; Arrays . new ( [ &quot;Dvorak&quot; , &quot;Tchaikovsky&quot; , &quot;Bruch&quot; ] ) # Arrays.Implementations.MapArray &lt; [ &quot;Dvorak&quot; , &quot;Tchaikovsky&quot; , &quot;Bruch&quot; ] &gt; By using Collectable : iex&gt; [ 1 , 2 , 3 ] |&gt; Enum . into ( Arrays . new ( ) ) # Arrays.Implementations.MapArray &lt; [ 1 , 2 , 3 ] &gt; iex&gt; for x &lt;- 1 .. 2 , y &lt;- 4 .. 5 , into : Arrays . new ( ) , do : { x , y } # Arrays.Implementations.MapArray &lt; [ { 1 , 4 } , { 1 , 5 } , { 2 , 4 } , { 2 , 5 } ] &gt; Some common array operations: Indexing is fast. The full Access calls are supported, Variants of many common Enum -like functions that keep the result an array (rather than turning it into a list), are available. iex&gt; words = Arrays . new ( [ &quot;the&quot; , &quot;quick&quot; , &quot;brown&quot; , &quot;fox&quot; , &quot;jumps&quot; , &quot;over&quot; , &quot;the&quot; , &quot;lazy&quot; , &quot;dog&quot; ] ) # Arrays.Implementations.MapArray &lt; [ &quot;the&quot; , &quot;quick&quot; , &quot;brown&quot; , &quot;fox&quot; , &quot;jumps&quot; , &quot;over&quot; , &quot;the&quot; , &quot;lazy&quot; , &quot;dog&quot; ] &gt; iex&gt; Arrays . size ( words ) # Runs in constant-time 9 iex&gt; words [ 3 ] # Indexing is fast &quot;fox&quot; iex&gt; words = put_in ( words [ 2 ] , &quot;purple&quot; ) # All of `Access` is supported # Arrays.Implementations.MapArray &lt; [ &quot;the&quot; , &quot;quick&quot; , &quot;purple&quot; , &quot;fox&quot; , &quot;jumps&quot; , &quot;over&quot; , &quot;the&quot; , &quot;lazy&quot; , &quot;dog&quot; ] &gt; iex&gt; Arrays . map ( words , &amp; String . upcase / 1 ) # Map a function, keep result an array # Arrays.Implementations.MapArray &lt; [ &quot;THE&quot; , &quot;QUICK&quot; , &quot;PURPLE&quot; , &quot;FOX&quot; , &quot;JUMPS&quot; , &quot;OVER&quot; , &quot;THE&quot; , &quot;LAZY&quot; , &quot;DOG&quot; ] &gt; iex&gt; lengths = Arrays . map ( words , &amp; String . length / 1 ) # Arrays.Implementations.MapArray &lt; [ 3 , 5 , 6 , 3 , 5 , 4 , 3 , 4 , 3 ] &gt; iex&gt; Arrays . reduce ( lengths , 0 , &amp; Kernel . + / 2 ) # `reduce_right` is supported as well. 36 Concatenating arrays: iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) |&gt; Arrays . concat ( Arrays . new ( [ 4 , 5 , 6 ] ) ) # Arrays.Implementations.MapArray &lt; [ 1 , 2 , 3 , 4 , 5 , 6 ] &gt; Slicing arrays: iex&gt; ints = Arrays . new ( 1 .. 100 ) iex&gt; Arrays . slice ( ints , 9 .. 19 ) # Arrays.Implementations.MapArray &lt; [ 10 , 11 , 12 , 13 , 14 , 15 , 16 , 17 , 18 , 19 , 20 ] &gt; Rationale Algorithms that use arrays can be used while abstracting away from the underlying representation. Which array implementation/representation is actually used, can then later be configured/compared, to make a trade-off between ease-of-use and time/memory efficiency. Arrays itself comes with two built-in implementations: Arrays.Implementations.ErlangArray wraps the Erlang :array module, allowing this time-tested implementation to be used with all common Elixir protocols and syntactic sugar. Arrays.Implementations.MapArray is a simple implementation that uses a map with sequential integers as keys. By default, Elixir.Arrays.Implementations.MapArray is used when creating new array objects, but this can be configured by either changing the default in your whole application, or by passing an option to a specific invocation of new/0-2 , or empty/0-1 . Protocols Besides being able to use all functions in this module, one can use the following protocols and behaviours with them: From Elixir's standard library: Enumerable : Iterating over arrays Collectable : Creating arrays from collections the Access behaviour: access a particular element using square brackets, put_in etc. From common container libraries: Insertable : Append a single item from the end of an array Extractable : Take a single item from the end of an array FunLand.Mappable : Map a function over each element in the array, creating a new array with the results FunLand.Reducible : Reduce an array to a single value. Note: FunLand is an optional dependency of this library, so its functionality will only be available if :fun_land is also added to your mix.exs dependencies list. Enumerable iex&gt; myarray = Arrays . new ( [ 2 , 1 , 4 , 2 , 0 ] ) iex&gt; Enum . sort ( myarray ) [ 0 , 1 , 2 , 2 , 4 ] iex&gt; Enum . count ( myarray ) 5 iex&gt; Enum . with_index ( myarray ) [ { 2 , 0 } , { 1 , 1 } , { 4 , 2 } , { 2 , 3 } , { 0 , 4 } ] iex&gt; Enum . slice ( myarray , 1 , 3 ) [ 1 , 4 , 2 ] iex&gt; names = Arrays . new ( [ &quot;Ernie&quot; , &quot;Bert&quot; , &quot;Kermit&quot; ] ) iex&gt; names |&gt; Stream . map ( &amp; String . upcase / 1 ) |&gt; Enum . into ( Arrays . new ( ) ) # Arrays.Implementations.MapArray &lt; [ &quot;ERNIE&quot; , &quot;BERT&quot; , &quot;KERMIT&quot; ] &gt; iex&gt; foods = Arrays . new ( [ &quot;Cheese&quot; , &quot;Strawberries&quot; , &quot;Cookies&quot; ] ) iex&gt; foods |&gt; Enum . take ( 2 ) [ &quot;Cheese&quot; , &quot;Strawberries&quot; ] iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) |&gt; Stream . zip ( Arrays . new ( [ 4 , 5 , 6 ] ) ) |&gt; Enum . take ( 2 ) [ { 1 , 4 } , { 2 , 5 } ] Collectable iex&gt; [ 10 , 20 , 30 , 40 ] |&gt; Enum . into ( Arrays . new ( ) ) # Arrays.Implementations.MapArray &lt; [ 10 , 20 , 30 , 40 ] &gt; Access Fast random-element access and updates are supported. iex&gt; arr = Arrays . new ( [ 1 , 2 , 3 , 4 ] ) iex&gt; arr = put_in ( arr [ 2 ] , 33 ) # Arrays.Implementations.MapArray &lt; [ 1 , 2 , 33 , 4 ] &gt; iex&gt; arr = update_in ( arr [ 1 ] , ( &amp; ( &amp;1 * - 2 ) ) ) # Arrays.Implementations.MapArray &lt; [ 1 , - 4 , 33 , 4 ] &gt; iex&gt; update_in ( arr [ - 1 ] , ( &amp; ( &amp;1 + 1 ) ) ) # Arrays.Implementations.MapArray &lt; [ 1 , - 4 , 33 , 5 ] &gt; Popping from a random location however, is not. Only removals of the last element of the array are fast. For this, use Arrays.extract/1 . iex&gt; arr = Arrays . new ( [ 1 , - 4 , 33 , 5 ] ) iex&gt; { 33 , _arr } = pop_in ( arr [ - 2 ] ) ** (ArgumentError) There is no efficient implementation possible to remove an element from a random location in an array, so `Access.pop/2` (and returning `:pop` from `Access.get_and_update/3` ) are not supported by Arrays.Implementations.MapArray. If you want to remove the last element, use `Arrays.extract/1`. iex&gt; arr2 = Arrays . new ( [ 10 , 20 , 30 ] ) iex&gt; { 20 , _arr2 } = get_and_update_in ( arr2 [ 1 ] , fn _ -&gt; :pop end ) ** (ArgumentError) There is no efficient implementation possible to remove an element from a random location in an array, so `Access.pop/2` (and returning `:pop` from `Access.get_and_update/3` ) are not supported by Arrays.Implementations.MapArray. If you want to remove the last element, use `Arrays.extract/1`. iex&gt; arr2 = Arrays . new ( [ 10 , 20 , 30 ] ) iex&gt; { :ok , { value , arr2 } } = Arrays . extract ( arr2 ) iex&gt; value 30 iex&gt; arr2 # Arrays.Implementations.MapArray &lt; [ 10 , 20 ] &gt; square-bracket access, get_in , put_in and update_in are very fast operations. Unless pop / pop_in is used for the last element in the array, is a very slow operation, as it requires moving of all elements after the given index in the array. Both positive indexes (counting from zero) and negative indexes ( -1 is the last element, -2 the second-to-last element, etc.) are supported. However, if positive_index &gt; Arrays.size(array) or negative_index &lt; -Arrays.size(array) , an ArgumentError is raised (when trying to put a new value), or :error is returned when fetching a value: iex&gt; arr = Arrays . new ( [ 1 , 2 , 3 , 4 ] ) iex&gt; put_in ( arr [ 4 ] , 1234 ) ** (ArgumentError) argument error iex&gt; arr = Arrays . new ( [ 1 , 2 , 3 , 4 ] ) iex&gt; put_in ( arr [ - 5 ] , 100 ) ** (ArgumentError) argument error iex&gt; arr = Arrays . new ( [ 1 , 2 , 3 , 4 ] ) iex&gt; Access . fetch ( arr , 4 ) :error iex&gt; Access . fetch ( arr , - 5 ) :error iex&gt; arr [ 4 ] nil iex&gt; arr [ - 5 ] nil iex&gt; arr = Arrays . new ( [ 1 , 2 , 3 , 4 ] ) iex&gt; update_in ( arr [ 8 ] , fn x -&gt; x * 2 end ) ** (ArgumentError) argument error iex&gt; arr = Arrays . new ( [ 1 , 2 , 3 , 4 ] ) iex&gt; update_in ( arr [ - 8 ] , fn x -&gt; x * 2 end ) ** (ArgumentError) argument error Insertable iex&gt; arr = Arrays . new ( ) iex&gt; { :ok , arr } = Insertable . insert ( arr , 42 ) iex&gt; { :ok , arr } = Insertable . insert ( arr , 100 ) iex&gt; arr # Arrays.Implementations.MapArray &lt; [ 42 , 100 ] &gt; Extractable iex&gt; Extractable . extract ( Arrays . new ( ) ) { :error , :empty } iex&gt; { :ok , { 3 , arr } } = Extractable . extract ( Arrays . new ( [ 1 , 2 , 3 ] ) ) iex&gt; arr # Arrays.Implementations.MapArray &lt; [ 1 , 2 ] &gt; FunLand.Reducible Note: FunLand is an optional dependency of this library. iex&gt; Arrays . new ( [ 1 , 2 , 3 , 4 ] ) |&gt; FunLand . reduce ( 0 , &amp; ( &amp;1 + &amp;2 ) ) 10 FunLand.Mappable iex&gt; Arrays . new ( [ 1 , 2 , 3 , 4 ] ) |&gt; FunLand.Mappable . map ( fn x -&gt; x * 2 end ) # Arrays.Implementations.MapArray &lt; [ 2 , 4 , 6 , 8 ] &gt; Arrays vs Lists Elixir widely uses List as default collection type. Compared to lists, Arrays have the folowing differences: Arrays keep track of their size . The size of a list needs to be computed. Arrays allow fast¹ element indexing . Indexing later elements in a list slows down linearly in the size of the list. Arrays allow fast slicing . For lists, this slows down the further away from the head of the list we are. Pushing a single element to the end of an array is fast¹. Pushing a single element to the end of a list is very slow (the whole list needs to be copied), taking linear time. Pushing a single element to the start of an array is slow, taking linear time (the whole array needs to be moved around). Pushing a single element to the head of a list is fast, taking constant time. Concatenating arrays takes time proportional to the size of the second array (individual elements are pushed to the end). Concatenating two lists takes time proportional to the length of the first list. This means that repeated appending Arrays are always well-formed. In certain cases, Lists are allowed to be improper. Many common operations in Elixir transform an enumerable into a list automatically. Arrays are made using Arrays.new/0 , Arrays.new/1 Arrays.empty/0 , the into: option on a for , or Enum.into . ¹: Depending on the implementation, 'fast' is either O(1) (constant time, regardless of array size) or O(log(n)) (logarithmic time, becoming a constant amount slower each time the array doubles in size.) The linear time many operations on lists take, means that the operation becomes twice as slow when the list doubles in size. Implementing a new Array type To add array-functionality to a custom datastructure, you'll need to implement the Arrays.Protocol . Besides these, you probably want to implement the above-mentioned protocols as well. You can look at the source code of Arrays.CommonProtocolImplementations for some hints as to how those protocols can be easily implemented, as many functions can be defined as simple wrappers on top of the functions that Arrays.Protocol itself already provides.","ref":"Arrays.html","title":"Arrays","type":"module"},{"doc":"Appends ('pushes') a single element to the end of the array. iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) |&gt; Arrays . append ( 4 ) # Arrays.Implementations.MapArray &lt; [ 1 , 2 , 3 , 4 ] &gt; See also extract/1 .","ref":"Arrays.html#append/2","title":"Arrays.append/2","type":"function"},{"doc":"Turns an array of arrays (or other enumerable of enumerables) into a single array. iex&gt; arr = Arrays . new ( [ 1 , 2 , 3 ] ) iex&gt; Arrays . concat ( [ arr , arr , arr ] ) # Arrays.Implementations.MapArray &lt; [ 1 , 2 , 3 , 1 , 2 , 3 , 1 , 2 , 3 ] &gt; iex&gt; Arrays . concat ( [ ] ) # Arrays.Implementations.MapArray &lt; [ ] &gt; See also concat/2 .","ref":"Arrays.html#concat/1","title":"Arrays.concat/1","type":"function"},{"doc":"Returns an array where all elements of right are added to the end of left . left should be an array. right can be either an array or any other enumerable. Takes time proportional to the number of elements in right . Essentially, each element in right is appended to left in turn. iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) |&gt; Arrays . concat ( Arrays . new ( [ 4 , 5 , 6 ] ) ) # Arrays.Implementations.MapArray &lt; [ 1 , 2 , 3 , 4 , 5 , 6 ] &gt; iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) |&gt; Arrays . concat ( ( 1 .. 10 ) ) # Arrays.Implementations.MapArray &lt; [ 1 , 2 , 3 , 1 , 2 , 3 , 4 , 5 , 6 , 7 , 8 , 9 , 10 ] &gt;","ref":"Arrays.html#concat/2","title":"Arrays.concat/2","type":"function"},{"doc":"Creates a new, empty, array. iex&gt; Arrays . empty ( ) # Arrays.Implementations.MapArray &lt; [ ] &gt; Options implementation: Module name of array-implementation to use. When not specified, will use the implementation which is configured in :arrays, :default_array_implementation , When no configuration is specified either, Elixir.Arrays.Implementations.MapArray will be used by default. iex&gt; Arrays . empty ( [ implementation : Arrays.Implementations.MapArray ] ) # Arrays.Implementations.MapArray &lt; [ ] &gt; iex&gt; Arrays . empty ( [ implementation : Arrays.Implementations.ErlangArray ] ) # Arrays.Implementations.ErlangArray &lt; [ ] &gt; Any other option is passed on to the particular array implementation. Not all array implementations recognize all options. However, the following two options are very common (and supported by both built-in implementations, Arrays.Implementations.ErlangArray and Arrays.Implementations.MapArray ): default: Value that empty elements should start with. (Default: nil ) size: Size of the array at start. (Default: 0) Using the MapArray iex&gt; Arrays . empty ( [ default : 42 , size : 5 , implementation : Arrays.Implementations.MapArray ] ) # Arrays.Implementations.MapArray &lt; [ 42 , 42 , 42 , 42 , 42 ] &gt; Using the ErlangArray iex&gt; Arrays . empty ( [ default : &quot;Empty&quot; , size : 1 , implementation : Arrays.Implementations.ErlangArray ] ) # Arrays.Implementations.ErlangArray &lt; [ &quot;Empty&quot; ] &gt;","ref":"Arrays.html#empty/1","title":"Arrays.empty/1","type":"function"},{"doc":"Extracts ('pops') a single element from the end of the array. Returns {:ok, item_that_was_removed, array_without_item} if the array was non-empty. When called on an empty array, {:error, :empty} is returned. iex&gt; { :ok , { elem , arr } } = Arrays . new ( [ 1 , 2 , 3 , 4 ] ) |&gt; Arrays . extract ( ) iex&gt; elem 4 iex&gt; arr # Arrays.Implementations.MapArray &lt; [ 1 , 2 , 3 ] &gt; iex&gt; Arrays . new ( [ ] ) |&gt; Arrays . extract ( ) { :error , :empty } See also append/2 .","ref":"Arrays.html#extract/1","title":"Arrays.extract/1","type":"function"},{"doc":"Retrieves the value stored in array of the element at index . Array indexes start at zero . iex&gt; Arrays . new ( [ 3 , 6 , 9 ] ) |&gt; Arrays . get ( 0 ) 3 iex&gt; Arrays . new ( [ 3 , 6 , 9 ] ) |&gt; Arrays . get ( 1 ) 6 As Array types also implement the Access behaviour, the [] (square-bracket) syntactic sugar can also be used: iex&gt; myarray = Arrays . new ( [ 2 , 4 , 8 ] ) iex&gt; myarray [ 0 ] 2 iex&gt; myarray [ 1 ] 4 Negative indexes It is also possible to use negative indexes, to read elements starting from the right side of the array. For example, index -1 works equivalently to size - 1 , if your array has size elements. iex&gt; names = Arrays . new ( [ &quot;Alice&quot; , &quot;Bob&quot; , &quot;Charlie&quot; , &quot;David&quot; ] ) iex&gt; Arrays . get ( names , - 2 ) &quot;Charlie&quot; iex&gt; names [ - 1 ] &quot;David&quot;","ref":"Arrays.html#get/2","title":"Arrays.get/2","type":"function"},{"doc":"Maps a function over an array, returning a new array. iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) |&gt; Arrays . map ( fn val -&gt; val * 2 end ) # Arrays.Implementations.MapArray &lt; [ 2 , 4 , 6 ] &gt;","ref":"Arrays.html#map/2","title":"Arrays.map/2","type":"function"},{"doc":"Creates a new, empty array with default options. iex&gt; Arrays . new ( ) # Arrays.Implementations.MapArray &lt; [ ] &gt;","ref":"Arrays.html#new/0","title":"Arrays.new/0","type":"function"},{"doc":"Creates a new array, receiving its elements from the given Enumerable , with default options.","ref":"Arrays.html#new/1","title":"Arrays.new/1","type":"function"},{"doc":"Creates a new array, receiving its elements from the given Enumerable , with the given options. Which options are supported depends on the type of array. iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) # Arrays.Implementations.MapArray &lt; [ 1 , 2 , 3 ] &gt; iex&gt; Arrays . new ( [ &quot;Hello&quot; ] ) # Arrays.Implementations.MapArray &lt; [ &quot;Hello&quot; ] &gt;","ref":"Arrays.html#new/2","title":"Arrays.new/2","type":"function"},{"doc":"Reduce an array to a single value, by calling the provided accumulation function for each element, left-to-right. If the array is empty, the accumulator argument acc is returned as result immediately. Otherwise, the function is called on all elements in the array, in order, with acc as second argument. The result of each of these function calls creates the new accumulator passed to the next invocation. iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) |&gt; Arrays . reduce ( 0 , fn val , sum -&gt; sum + val end ) 6 iex&gt; Arrays . new ( [ &quot;the&quot; , &quot;quick&quot; , &quot;brown&quot; , &quot;fox&quot; ] ) |&gt; Arrays . reduce ( &quot;&quot; , fn val , result -&gt; result &lt;&gt; &quot; &quot; &lt;&gt; val end ) &quot; the quick brown fox&quot; iex&gt; Arrays . new ( [ ] ) |&gt; Arrays . reduce ( 1234 , fn val , mul -&gt; mul * val end ) 1234 See also reduce_right/3 .","ref":"Arrays.html#reduce/3","title":"Arrays.reduce/3","type":"function"},{"doc":"Reduce an array to a single value, by calling the provided accumulation function for each element, right-to-left. If the array is empty, the accumulator argument acc is returned as result immediately. Otherwise, the function is called on all elements in the array, in reverse (right-to-left) order, with acc as first argument. The result of each of these function calls creates the new accumulator passed to the next invocation. iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) |&gt; Arrays . reduce_right ( 0 , fn sum , val -&gt; sum + val end ) 6 iex&gt; Arrays . new ( [ &quot;the&quot; , &quot;quick&quot; , &quot;brown&quot; , &quot;fox&quot; ] ) |&gt; Arrays . reduce_right ( &quot;&quot; , fn result , val -&gt; result &lt;&gt; &quot; &quot; &lt;&gt; val end ) &quot; fox brown quick the&quot; iex&gt; Arrays . new ( [ ] ) |&gt; Arrays . reduce_right ( 1234 , fn mul , val -&gt; mul * val end ) 1234 See also reduce/3 .","ref":"Arrays.html#reduce_right/3","title":"Arrays.reduce_right/3","type":"function"},{"doc":"Replaces the element in array at index with value . iex&gt; Arrays . new ( [ 4 , 5 , 6 ] ) |&gt; Arrays . replace ( 1 , 69 ) # Arrays.Implementations.MapArray &lt; [ 4 , 69 , 6 ] &gt; Just like get/2 , negative indices are supported. iex&gt; Arrays . new ( [ 7 , 8 , 9 ] ) |&gt; Arrays . replace ( - 1 , 33 ) # Arrays.Implementations.MapArray &lt; [ 7 , 8 , 33 ] &gt;","ref":"Arrays.html#replace/3","title":"Arrays.replace/3","type":"function"},{"doc":"Changes the size of the array. When the array becomes larger, new elements at the end will al receive the default value. When the array becomes smaller, elements larger than the new size will be dropped. iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) |&gt; Arrays . resize ( 6 ) # Arrays.Implementations.MapArray &lt; [ 1 , 2 , 3 , nil , nil , nil ] &gt; iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) |&gt; Arrays . resize ( 5 , 42 ) # Arrays.Implementations.MapArray &lt; [ 1 , 2 , 3 , 42 , 42 ] &gt; iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) |&gt; Arrays . resize ( 1 ) # Arrays.Implementations.MapArray &lt; [ 1 ] &gt; iex&gt; Arrays . new ( [ 9 , 8 , 7 ] ) |&gt; Arrays . resize ( 0 ) # Arrays.Implementations.MapArray &lt; [ ] &gt; iex&gt; Arrays . new ( [ 1 , 2 , 3 ] ) |&gt; Arrays . resize ( 3 ) # Arrays.Implementations.MapArray &lt; [ 1 , 2 , 3 ] &gt; See also size/1 .","ref":"Arrays.html#resize/3","title":"Arrays.resize/3","type":"function"},{"doc":"The number of elements in the array. Looking up the size of an array is fast: this function runs in constant time. iex&gt; Arrays . new ( [ 2 , 4 , 6 ] ) |&gt; Arrays . size ( ) 3 iex&gt; Arrays . new ( [ ] ) |&gt; Arrays . size ( ) 0 See also resize/2 .","ref":"Arrays.html#size/1","title":"Arrays.size/1","type":"function"},{"doc":"Returns a sub-array of the given array by index_range . index_range must be a Range . Given an array, it drops elements before index_range.first (zero-based), then it takes elements until element index_range.last (inclusively). Indexes are normalized, meaning that negative indexes will be counted from the end (for example, -1 means the last element of the array). If index_range.last is out of bounds, then it is assigned as the index of the last element. If the normalized index_range.first is out of bounds of the given array, or if it is is greater than the normalized index_range.last , then an empty array is returned. iex&gt; Arrays . slice ( Arrays . new ( [ 1 , 2 , 3 , 4 , 5 , 6 ] ) , 2 .. 4 ) # Arrays.Implementations.MapArray &lt; [ 3 , 4 , 5 ] &gt; iex&gt; Arrays . slice ( Arrays . new ( 1 .. 100 ) , 5 .. 10 ) # Arrays.Implementations.MapArray &lt; [ 6 , 7 , 8 , 9 , 10 , 11 ] &gt; iex&gt; Arrays . slice ( Arrays . new ( 1 .. 10 ) , 5 .. 20 ) # Arrays.Implementations.MapArray &lt; [ 6 , 7 , 8 , 9 , 10 ] &gt; # last five elements (negative indexes) iex&gt; Arrays . slice ( Arrays . new ( 1 .. 30 ) , - 5 .. - 1 ) # Arrays.Implementations.MapArray &lt; [ 26 , 27 , 28 , 29 , 30 ] &gt; If values are out of bounds, it returns an empty array: iex&gt; Arrays . slice ( Arrays . new ( 1 .. 10 ) , 11 .. 20 ) # Arrays.Implementations.MapArray &lt; [ ] &gt; # first is greater than last iex&gt; Arrays . slice ( Arrays . new ( 1 .. 10 ) , 6 .. 5 ) # Arrays.Implementations.MapArray &lt; [ ] &gt; See also slice/3 . This function is similar to Enum.slice/2 , but will always return an array (whereas Enum.slice will return a list). Slicing on arrays is significantly faster than slicing on plain lists or maps, as there is no need to iterate over all elements we're going to skip since we can index them directly.","ref":"Arrays.html#slice/2","title":"Arrays.slice/2","type":"function"},{"doc":"Returns a sub-array of the given array, from start_index (zero-based) with amount number of elements if available. Given an array, it skips elements right before element start_index ; then, it takes amount of elements, returning as many elements as possible if there are not enough elements. A negative start_index can be passed, which means the array is enumerated once and the index is counted from the end (for example, -1 starts slicing from the last element). It returns an empty array if amount is 0 or if start_index is out of bounds. iex&gt; Arrays . slice ( Arrays . new ( [ 1 , 2 , 3 , 4 , 5 , 6 ] ) , 2 , 4 ) # Arrays.Implementations.MapArray &lt; [ 3 , 4 , 5 , 6 ] &gt; iex&gt; Arrays . slice ( Arrays . new ( [ 1 , 2 , 3 , 4 , 5 , 6 ] ) , 10 , 20 ) # Arrays.Implementations.MapArray &lt; [ ] &gt; iex&gt; Arrays . slice ( Arrays . new ( 1 .. 100 ) , 5 , 10 ) # Arrays.Implementations.MapArray &lt; [ 6 , 7 , 8 , 9 , 10 , 11 , 12 , 13 , 14 , 15 ] &gt; # amount to take is greater than the number of elements iex&gt; Arrays . slice ( Arrays . new ( 1 .. 10 ) , 5 , 100 ) # Arrays.Implementations.MapArray &lt; [ 6 , 7 , 8 , 9 , 10 ] &gt; iex&gt; Arrays . slice ( Arrays . new ( 1 .. 10 ) , 5 , 0 ) # Arrays.Implementations.MapArray &lt; [ ] &gt; # using a negative start index iex&gt; Arrays . slice ( Arrays . new ( 1 .. 10 ) , - 6 , 3 ) # Arrays.Implementations.MapArray &lt; [ 5 , 6 , 7 ] &gt; # out of bound start index (positive) iex&gt; Arrays . slice ( Arrays . new ( 1 .. 10 ) , 10 , 5 ) # Arrays.Implementations.MapArray &lt; [ ] &gt; # out of bound start index (negative) iex&gt; Arrays . slice ( Arrays . new ( 1 .. 10 ) , - 11 , 5 ) # Arrays.Implementations.MapArray &lt; [ ] &gt; See also slice/2 . This function is similar to Enum.slice/3 , but will always return an array (whereas Enum.slice will return a list). Slicing on arrays is significantly faster than slicing on plain lists or maps, as there is no need to iterate over all elements we're going to skip since we can index them directly.","ref":"Arrays.html#slice/3","title":"Arrays.slice/3","type":"function"},{"doc":"Transforms the array into a list. iex&gt; Arrays . new ( [ &quot;Joe&quot; , &quot;Mike&quot; , &quot;Robert&quot; ] ) |&gt; Arrays . to_list [ &quot;Joe&quot; , &quot;Mike&quot; , &quot;Robert&quot; ]","ref":"Arrays.html#to_list/1","title":"Arrays.to_list/1","type":"function"},{"doc":"Any datatype implementing the Arrays.Protocol .","ref":"Arrays.html#t:array/0","title":"Arrays.array/0","type":"type"},{"doc":"An array index can be either a nonnegative index (up to the size of the array), or a negative index (then we count backwards from the size.)","ref":"Arrays.html#t:index/0","title":"Arrays.index/0","type":"type"},{"doc":"Type of the kind of value stored in the array. In practice, arrays can store anything so this is an alias for any .","ref":"Arrays.html#t:value/0","title":"Arrays.value/0","type":"type"},{"doc":"Wraps the Erlang :array module. These kinds of arrays use a 'functional tree' format, with a leaf size of 10 nodes wide ( ref. ). Common operations like element access thus take O(log10(n)) time. Note that when no custom default value is specified, nil will be used, rather than :array 's default of :undefined .","ref":"Arrays.Implementations.ErlangArray.html","title":"Arrays.Implementations.ErlangArray","type":"module"},{"doc":"Create an %ErlangArray{} -struct from an :array -record. iex&gt; :array . new ( [ ] ) |&gt; ErlangArray . from_raw ( ) # Arrays.Implementations.ErlangArray &lt; [ ] &gt;","ref":"Arrays.Implementations.ErlangArray.html#from_raw/1","title":"Arrays.Implementations.ErlangArray.from_raw/1","type":"function"},{"doc":"Implementation for FunLand.Mappable.map . Note that FunLand is an optional dependency of Arrays so you need to add it to your mix.exs dependencies manually to use it.","ref":"Arrays.Implementations.ErlangArray.html#map/2","title":"Arrays.Implementations.ErlangArray.map/2","type":"function"},{"doc":"A variant of reduce that accepts anything that is Combinable as second argument. This Combinable will determine what the empty value and the combining operation will be. Pass in the combinable module name to start with empty as accumulator, or the combinable as struct to use that as starting accumulator. This is an automatic function implementation, made possible because Arrays.Implementations.ErlangArray implements the FunLand.Reducible behaviour. See FunLand.Reducible.reduce/2 for examples.","ref":"Arrays.Implementations.ErlangArray.html#reduce/2","title":"Arrays.Implementations.ErlangArray.reduce/2","type":"function"},{"doc":"Implementation for FunLand.Reducible.reduce . Note that FunLand is an optional dependency of Arrays so you need to add it to your mix.exs dependencies manually to use it.","ref":"Arrays.Implementations.ErlangArray.html#reduce/3","title":"Arrays.Implementations.ErlangArray.reduce/3","type":"function"},{"doc":"Converts the reducible into a list, by building up a list from all elements, and in the end reversing it. This is an automatic function implementation, made possible because Arrays.Implementations.ErlangArray implements the FunLand.Reducible behaviour.","ref":"Arrays.Implementations.ErlangArray.html#to_list/1","title":"Arrays.Implementations.ErlangArray.to_list/1","type":"function"},{"doc":"Turn an %ErlangArray{}-struct back into an :array -record. iex&gt; Arrays . new ( [ 1 , 2 , 3 ] , implementation : Arrays.Implementations.ErlangArray ) |&gt; ErlangArray . to_raw ( ) { :array , 3 , 10 , nil , { 1 , 2 , 3 , nil , nil , nil , nil , nil , nil , nil } }","ref":"Arrays.Implementations.ErlangArray.html#to_raw/1","title":"Arrays.Implementations.ErlangArray.to_raw/1","type":"function"},{"doc":"An array implementation based on the built-in Map structure.","ref":"Arrays.Implementations.MapArray.html","title":"Arrays.Implementations.MapArray","type":"module"},{"doc":"Implementation for FunLand.Mappable.map . Note that FunLand is an optional dependency of Arrays so you need to add it to your mix.exs dependencies manually to use it.","ref":"Arrays.Implementations.MapArray.html#map/2","title":"Arrays.Implementations.MapArray.map/2","type":"function"},{"doc":"A variant of reduce that accepts anything that is Combinable as second argument. This Combinable will determine what the empty value and the combining operation will be. Pass in the combinable module name to start with empty as accumulator, or the combinable as struct to use that as starting accumulator. This is an automatic function implementation, made possible because Arrays.Implementations.MapArray implements the FunLand.Reducible behaviour. See FunLand.Reducible.reduce/2 for examples.","ref":"Arrays.Implementations.MapArray.html#reduce/2","title":"Arrays.Implementations.MapArray.reduce/2","type":"function"},{"doc":"Implementation for FunLand.Reducible.reduce . Note that FunLand is an optional dependency of Arrays so you need to add it to your mix.exs dependencies manually to use it.","ref":"Arrays.Implementations.MapArray.html#reduce/3","title":"Arrays.Implementations.MapArray.reduce/3","type":"function"},{"doc":"Converts the reducible into a list, by building up a list from all elements, and in the end reversing it. This is an automatic function implementation, made possible because Arrays.Implementations.MapArray implements the FunLand.Reducible behaviour.","ref":"Arrays.Implementations.MapArray.html#to_list/1","title":"Arrays.Implementations.MapArray.to_list/1","type":"function"},{"doc":"This module is only interesting for people wanting to implement their own array datatype. It does not contain any functions itself directly, but its source code might be useful to see example implementations of the various protocols and behaviours that Array types ought to implement. Most of these can probably be re-used 1:1 for custom Array types.","ref":"Arrays.CommonProtocolImplementations.html","title":"Arrays.CommonProtocolImplementations","type":"module"},{"doc":"This protocol is implemented by all array types. Do not call functions in this module directly if you want to use an array in your code. Instead, use the functions in the Arrays module, which will use the methods of this protocol.","ref":"Arrays.Protocol.html","title":"Arrays.Protocol","type":"protocol"},{"doc":"Appends ('pushes') a single element to the end of the array. Called by Arrays.append/2","ref":"Arrays.Protocol.html#append/2","title":"Arrays.Protocol.append/2","type":"function"},{"doc":"Should create a new instance of your custom array type. This is called internally by functions such as Arrays.new/0 and Arrays.empty/1 . NOTE: This function will not be dispatched by normal protocol handling. It will be called directly: The first (and only) parameter will be a list of options. c.f. t:options .","ref":"Arrays.Protocol.html#empty/1","title":"Arrays.Protocol.empty/1","type":"function"},{"doc":"Extracts ('pops') a single element from the end of the array. Called by Arrays.extract/1","ref":"Arrays.Protocol.html#extract/1","title":"Arrays.Protocol.extract/1","type":"function"},{"doc":"Retrieves the value stored in array of the element at index . Called by Arrays.get/2","ref":"Arrays.Protocol.html#get/2","title":"Arrays.Protocol.get/2","type":"function"},{"doc":"Maps a function over an array, returning a new array. Called by Arrays.map/2","ref":"Arrays.Protocol.html#map/2","title":"Arrays.Protocol.map/2","type":"function"},{"doc":"Reduce an array to a single value, by calling the provided accumulation function for each element, left-to-right. Note that fun takes the accumulator as second (right) parameter and the item as first (left) parameter. Called by Arrays.reduce/3","ref":"Arrays.Protocol.html#reduce/3","title":"Arrays.Protocol.reduce/3","type":"function"},{"doc":"Reduce an array to a single value, by calling the provided accumulation function for each element, right-to-left. Note that fun takes the accumulator as first (left) parameter and the item as second (right) parameter. Called by Arrays.reduce_right/3","ref":"Arrays.Protocol.html#reduce_right/3","title":"Arrays.Protocol.reduce_right/3","type":"function"},{"doc":"Replaces the element in array at index with value . Called by Arrays.replace/3","ref":"Arrays.Protocol.html#replace/3","title":"Arrays.Protocol.replace/3","type":"function"},{"doc":"Changes the size of the array. When made smaller, truncates elements beyond the first size elements will be removed. When made larger, new elements will receive default as value. Called by Arrays.resize/2","ref":"Arrays.Protocol.html#resize/3","title":"Arrays.Protocol.resize/3","type":"function"},{"doc":"The number of elements in the array. Called by Arrays.size/1","ref":"Arrays.Protocol.html#size/1","title":"Arrays.Protocol.size/1","type":"function"},{"doc":"Return a contiguous slice of some elements in the array. Handling of bounds is handled in the Arrays module, so we know for certain that 0 &lt;= start_index &lt; size(array) and start_index + length &lt; size(array) .","ref":"Arrays.Protocol.html#slice/3","title":"Arrays.Protocol.slice/3","type":"function"},{"doc":"Transforms the array into a list. Called by Arrays.to_list/1","ref":"Arrays.Protocol.html#to_list/1","title":"Arrays.Protocol.to_list/1","type":"function"},{"doc":"Any datatype implementing the Arrays.Protocol .","ref":"Arrays.Protocol.html#t:array/0","title":"Arrays.Protocol.array/0","type":"type"},{"doc":"An array index can be either a nonnegative index (up to the size of the array), or a negative index (then we count backwards from the size.)","ref":"Arrays.Protocol.html#t:index/0","title":"Arrays.Protocol.index/0","type":"type"},{"doc":"A list of options passed to empty/1 . What options are recognized by a particular implementation varies.","ref":"Arrays.Protocol.html#t:options/0","title":"Arrays.Protocol.options/0","type":"type"},{"doc":"","ref":"Arrays.Protocol.html#t:t/0","title":"Arrays.Protocol.t/0","type":"type"},{"doc":"Type of the kind of value stored in the array. In practice, arrays can store anything so this is an alias for any .","ref":"Arrays.Protocol.html#t:value/0","title":"Arrays.Protocol.value/0","type":"type"}]